/* Collector */
/* May 17, 2005 */

#include <stdio.h>
#include <string.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>

#include "bbrl.h"

#define COLLECTORPORT 16720
#if defined(__GNU_LIBRARY__) && !defined(MSG_WAITALL)
#define MSG_WAITALL 0x100
#endif

char databasehost[1024],recorderhost[1024];
char trans[1024];
int pedflag = 0,runflag = 0;


void execsavemode(){
  memset(trans,0,1024);
  sprintf(trans,"%s/transfer %s %s save &",BBRL_DIR,databasehost,recorderhost);
  system(trans);
}

void execnosavemode(){
  memset(trans,0,1024);
  sprintf(trans,"%s/transfer %s %s nosave &",BBRL_DIR,databasehost,recorderhost);
  system(trans);
}

void execinsmod(){
  system("/sbin/insmod babarldaq.o");
}

void execrmmod(){
  system("/sbin/rmmod babarldaq");
}

void execpedmode(){
  memset(trans,0,1024);
  sprintf(trans,"%s/transfer %s %s save &",BBRL_DIR,databasehost,recorderhost);
  system(trans);
}

void execpedinsmod(){
  system("/sbin/insmod pedreader.o");
}

void execpedrmmod(){
  system("/sbin/rmmod pedreader");
}

void execpedsetter(){
  memset(trans,0,1024);
  sprintf(trans,"%s/setsta",BBRL_DIR);
  system(trans);
}

void execthresetter(){
  memset(trans,0,1024);
  sprintf(trans,"%s/setthre",BBRL_DIR);
  system(trans);
}


int main(int argc,char *argv[]){
  int i;
  int sock1,sock2;
  struct sockaddr_in saddr,caddr;
  int len;
  char sendbuf = 1;
  char command[1024];
  int sockopt = 1;


  if((sock1 = socket(AF_INET,SOCK_STREAM,0)) < 0){
    perror("Socket");
    exit(1);
  }

  setsockopt(sock1,SOL_SOCKET,SO_REUSEADDR,&sockopt,sizeof(sockopt));

  memset((char *)&saddr,0,sizeof(saddr));
  memset(databasehost,0,1024);
  memset(recorderhost,0,1024);

  saddr.sin_family = AF_INET;
  saddr.sin_addr.s_addr = INADDR_ANY;
  saddr.sin_port = htons(COLLECTORPORT);

  /* bind sock1 */
  if(bind(sock1,(struct sockaddr *)&saddr,sizeof(saddr)) < 0){
    perror("Error in bind sock1.\n");
    exit(1);
  }

  /* listen sock1 */
  if(listen(sock1,1) < 0){
    perror("Error in listen sock1.\n");
    exit(1);
  }

  len = sizeof(caddr);

  /* accept */
  if((sock2 = accept(sock1,(struct sockaddr *)&caddr,&len)) < 0){
    perror("Error in accept.\n");
    exit(1);
  }
  close(sock1);
  while(1){
    recv(sock2,command,1024,MSG_WAITALL);
    switch (command[0]){
    case 1: // Run Start
      runflag = 1;
      execsavemode();
      execinsmod();
      printf("Start\n"); // TEST
      send(sock2,&sendbuf,1,0);
      break;
    case 2: // Run Stop
      runflag = 0;
      if(pedflag == 0){
	execrmmod();
      }else{
	execpedrmmod();
	pedflag = 0;
      }
      send(sock2,&sendbuf,1,0);
      break;
    case 3: // No save run Start
      printf("No save mode...\n");
      runflag = 1;
      printf("runflag = %d\n",runflag);
      execnosavemode();
      execinsmod();
      printf("Start with nosave mode\n"); // TEST
      send(sock2,&sendbuf,1,0);
      break;
    case 9: // No save pedestal run Start
      pedflag = 1;
      runflag = 1;
      execnosavemode();
      execpedinsmod();
      printf("Start with pedestal run without save\n"); // TEST
      send(sock2,&sendbuf,1,0);
      break;
    case 4: // Set Database Address
      memcpy(databasehost,command+1,strlen(command+1));
      send(sock2,&sendbuf,1,0);
      break;
    case 5: // Set Recorder Address
      memcpy(recorderhost,command+1,strlen(command+1));
      send(sock2,&sendbuf,1,0);
      printf("%s\n",recorderhost);
      break;
    case 6: // Pedestal Run Start
      runflag = 1;
      pedflag = 1;
      execpedmode();
      execpedinsmod();
      printf("Pedestal Start\n"); // TEST
      send(sock2,&sendbuf,1,0);
      break;
    case 7: // Set Pedestal
      execpedsetter();
      printf("Set Pedestal\n"); // TEST
      send(sock2,&sendbuf,1,0);
      break;
    case 8: // Set Threshold
      execthresetter();
      printf("Set Threshold\n");
      send(sock2,&sendbuf,1,0);
      break;
    case 91: // Check Process
      send(sock2,&sendbuf,1,0);
      break;
    case 92: // Exit Collector
      send(sock2,&sendbuf,1,0);
      close(sock2);
      if(runflag != 0){
	runflag = 0;
	if(pedflag == 0){
	  execrmmod();
	}else{
	  execpedrmmod();
	}
      }
      exit(0);
      break;
    }
  }
}
