/* controller
   May 17, 2005

   using ncurses 
         thread
   TCP Only mode
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include <termios.h>
#include <curses.h>
#include <time.h>
#include <unistd.h>
#include <pthread.h>

#include "getmtstat.c"
#include "bbrl.h"
//#include "iLog.h"
//#include "iLogClient.h"

#if defined(__GNU_LIBRARY__) && !defined(MSG_WAITALL)
#define MSG_WAITALL 0x100
#endif

void mtfullstop(void);

/* Address */
struct Address{
  char database[40];
  char recorder[40];
  char collector[40];
  //  char iLogServer[40];
}address;

unsigned int hdfullsize,mtfullsize,fulldisk;
int autorunflag,autorunn,autostock,autostop;
int i,xc=0,yc=20,xb=21,yb=4,xmes=21,ymes=10,xh=10,yh=13,xsta=2,ysta=3;
char com[40],tmp[40];
char header[256],ender[256],tmpstr[1024];
char chrunnumber[7],chstart[18],chstop[18],chprint[18],chdate[14];
char comment[100];
unsigned int starttime,stoptime;
unsigned short runnumber,run;
FILE *fp;
int dbsock,recsock,colsock,hdn,maxhd;
struct sockaddr_in dbsaddr,recsaddr,colsaddr;
static struct hostent *dbent,*recent,*colent;
char sendbuf[1024],recvbuf[1024];
int command,headerflag,mtflag,stmode,mtnum;
/* mtflag  1 : mton succeed
           0 : mton failed
   stmod   1 : MT mode
           0 : HD mode
   mtnum   1 : MT ond
           2 : MT two
*/
unsigned static int startflag = 0,mtfullstopflag = 0, commentflag = 0;
time_t ttime,nowtime;
struct tm *strtime;
char startchar[40],stopchar[40];
char hddir1[256],hddir2[256],tmp1[256],tmp2[256];

unsigned int mtfull,mtused;
pthread_t timerthread_t;
int timer = 0;

/* Screen */
static int hascolor = 0,bgcolor = -1;
attr_t redstr,bluestr,linestr,cyanstr,yellowstr;


/* Timer Thread */
void showdate(void){
  int cuy,cux;
  getsyx(cuy,cux);
  time(&nowtime);
  attron(cyanstr);
  mvprintw(2,55,"%s",ctime(&nowtime));
  attroff(cyanstr);
  move(cuy,cux);
  refresh();
}


void prisca(void){
  char syschar[80];
  sprintf(syschar,"%s/prisca -n",BBRL_DIR);
  system(syschar);
}

void stdsca(void){
  char syschar[80];
  sprintf(syschar,"%s/stdsca -n",BBRL_DIR);
  system(syschar);
}


void showmtstat(void){
  int cuy,cux;
  float percent;

  getmtstat(&mtfull,&mtused);
  getsyx(cuy,cux);
  if(stmode == 0){
    mvprintw(17,41,"HD  Used %d / Full %d",mtused,mtfull);
  }else{
    mvprintw(17,41,"MT  Used %d / Full %d",mtused,mtfull);
  }
  percent = (float)(mtused*100)/(float)mtfull;
  if(percent > 95){
    attron(redstr);
    printw("  (%2.1f\%)      ",percent);
    attroff(redstr);
  }else{
    printw("  (%2.1f\%)      ",percent);
  }    
  move(cuy,cux);
  refresh();
  if(mtused > mtfull && startflag == 1){
    mtfullstop();
  }
}

void timerthread(void){
  while(1){
    if(startflag != 0 && timer%5 == 0){
      showmtstat();
    }
    showdate();
    sleep(1);
  }
}

void showststat(void){
  if(stmode == 1){
    mvprintw(17,10,"MT Mode      ");
    if(mtnum == 2){
      printw("x2");
    }else{
      printw("x1");
    }
  }else{
    mvprintw(17,10,"HD Mode      ");
    if(hdn == 2){
      printw("x2");
    }else{
      printw("x1");
    }
  }
}

/* Make Header and Ender */
void makeComment(int md){
  /* md == 0 : Header
     md == 1 : Ender  */
  if(md == 0){
    ttime = starttime;
  }else{
    ttime = stoptime;
  }
  strtime = localtime(&ttime);
  sprintf(chrunnumber,"RUN-%04d",runnumber);
  if(md == 0){
    strftime(chstart,18,"START => %X",strtime);
    strftime(chstop,18," STOP => XX:XX:XX",strtime);
  }else{
    strftime(chstop,18," STOP => %X ",strtime);
  }
  sprintf(chprint,"Print -> XX:XX:XX ");
  strftime(chdate,14," %d-%b-%y",strtime);
  memset(comment,0x20,100);
  if(md == 0){
    comment[0] = 0x01;
    comment[1] = 0x00;
  }else{
    comment[0] = 0xff;
    comment[1] = 0xff;
  }
  for(i=2;i<20;i++){
    comment[i] = 0;
  }
  memcpy(comment+20,chrunnumber,8);
  memcpy(comment+30,chstart,17);
  memcpy(comment+48,chstop,17);
  memcpy(comment+68,chprint,18);
  memcpy(comment+86,chdate,10);
  memset(comment+96,0,4);
}

/* Command */
int getStrcmp(char *co){
  return strcmp(com,co);
}

int getCommand(void){
  if(getStrcmp("start") == 0){
    return 1;
  }else if(getStrcmp("sta") == 0){
    return 1;
  }else if(getStrcmp("sto") == 0){
    return 2;
  }else if(getStrcmp("stop") == 0){
    return 2;
  }else if(getStrcmp("nosave") == 0){
    return 3;
  }else if(getStrcmp("nssta") == 0){
    return 3;
  }else if(getStrcmp("header") == 0){
    return 4;
  }else if(getStrcmp("wth") == 0){
    return 4;
  }else if(getStrcmp("exit") == 0){
    return 5;
  }else if(getStrcmp("check") == 0){
    return 6;
  }else if(getStrcmp("addclient") == 0){
    return 7;
  }else if(getStrcmp("addcli") == 0){
    return 7;
  }else if(getStrcmp("mton") == 0){
    return 8;
  }else if(getStrcmp("mtoff") == 0){
    return 9;
  }else if(getStrcmp("hdon") == 0){
    return 10;
  }else if(getStrcmp("mtone") == 0){
    return 11;
  }else if(getStrcmp("mttwo") == 0){
    return 12;
  }else if(getStrcmp("mou") == 0){
    return 13;
  }else if(getStrcmp("mount") == 0){
    return 13;
  }else if(getStrcmp("dismou") == 0){
    return 14;
  }else if(getStrcmp("dismount") == 0){
    return 14;
  }else if(getStrcmp("setnumber") == 0){
    return 21;
  }else if(getStrcmp("updatescr") == 0){
    return 22;
  }else if(getStrcmp("clear") == 0){
    return 23;
  }else if(getStrcmp("cle") == 0){
    return 23;
  }else if(getStrcmp("help") == 0){
    return 30;
  }else if(getStrcmp("prisca") == 0){
    return 31;
  }else if(getStrcmp("stdsca") == 0){
    return 32;
  }else if(getStrcmp("cc") == 0){
    return 33;
  }else if(getStrcmp("hdon1") == 0){
    return 35;
  }else if(getStrcmp("hdon2") == 0){
    return 36;
  }else if(getStrcmp("max") == 0){
    return 37;
  }else if(getStrcmp("auto") == 0){
    return 38;
  }else if(strlen(com) == 0){
    return 40;
  }else{
    return 0;
  }
}

/* Exit */
void exitCommand(void){
#ifndef DEBUG
  sendbuf[0] = 92;
  send(dbsock,sendbuf,1024,0);
  send(colsock,sendbuf,1024,0);
  send(recsock,sendbuf,1024,0);
#endif
  close(dbsock);
  close(recsock);
  close(colsock);
  exit(0);
}

/* Process Check */
void checkCommand(void){
  sendbuf[0] = 91;
  recvbuf[0] = 0;
  send(dbsock,sendbuf,1024,0);
  recv(dbsock,recvbuf,1,MSG_WAITALL);
  if(recvbuf[0] == 1){
    mvprintw(ymes+1,xmes,"Database OK             ");
  }
  recvbuf[0] = 0;
  send(colsock,sendbuf,1024,0);
  recv(colsock,recvbuf,1,MSG_WAITALL);
  if(recvbuf[0] == 1){
    mvprintw(ymes+2,xmes,"Collector OK            ");
  }
  recvbuf[0] = 0;
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
  if(recvbuf[0] == 1){
    mvprintw(ymes+3,xmes,"Recorder OK             ");
  }
}
 
/* add Multi Client */
void addClientCommand(void){
  move(yc+1,xc);
  deleteln();
  printw("Hostname> ");
  if(scanw("%s",sendbuf+1) > 0){
    move(yc+1,xc);
    deleteln();
    sendbuf[0] = 41;
    send(dbsock,sendbuf,1024,0);
    recv(dbsock,recvbuf,1,MSG_WAITALL);
    if(recvbuf[0] == 1){
      mvprintw(ymes,xmes,"Success add client           ");
    }else{
      mvprintw(ymes,xmes,"False add client             ");
    }
  }
}


void setfulldisk(void){
  if(stmode == 0){
    fulldisk = hdfullsize;
  }else{
    fulldisk = mtfullsize;
  }

  sendbuf[0] = 49;
  memcpy(sendbuf+1,(char *)&fulldisk,4);
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
}

void sethddir1(void){
  sendbuf[0] = 43;
  memcpy(sendbuf+1,hddir1,strlen(hddir1));
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
}

void sethddir2(void){
  sendbuf[0] = 44;
  memcpy(sendbuf+1,hddir2,strlen(hddir2));
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
}

/* MT Commands */
void mton(void){
  sendbuf[0] = 51;
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
  if(recvbuf[0] != 0){
    mtflag = 1;
  }else{
    mtflag = 0;
  }
  stmode = 1;
  setfulldisk();
  showmtstat();
  showststat();
}

void mtmou(void){
  sendbuf[0] = 55;
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
}

void mtdismou(void){
  sendbuf[0] = 59;
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
  mtflag = 0;
  stmode = 0;
  showmtstat();
  showststat();
}

void hdon(void){
  sendbuf[0] = 42;
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
  mtflag = 0;
  stmode = 0;
  setfulldisk();
  showmtstat();
  showststat();
}

void mtone(void){
  sendbuf[0] = 52;
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
  mtnum = 1;
  setfulldisk();
  showmtstat();
  showststat();
}

void mttwo(void){
  sendbuf[0] = 53;
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
  mtnum = 2;
  setfulldisk();
  showmtstat();
  showststat();
}

void sethd1(void){
  hdn = 1;
  sendbuf[0] = 45;
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
  mtflag = 0;
  stmode = 0;
  setfulldisk();
  showmtstat();
  showststat();
}

void sethd2(void){
  hdn = 2;
  sendbuf[0] = 46;
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
  mtflag = 0;
  stmode = 0;
  setfulldisk();
  showmtstat();
  showststat();
}

/* Draw Box */
void drawbox(int xbase,int ybase,int xlength,int ydepth){
  chtype bottom[xlength+1];
  int n;

  if(hascolor)
    attrset(COLOR_PAIR(3));

  mvaddch(ybase - 1,  xbase - 1, ACS_ULCORNER);
  hline(ACS_HLINE, xlength);
  mvaddch(ybase - 1,  xbase + xlength, ACS_URCORNER);

  mvaddch(ybase + ydepth,  xbase - 1, ACS_LLCORNER);
  mvinchnstr(ybase + ydepth, xbase, bottom, xlength);
  for (n = 0; n < xlength; n++)
    bottom[n] = ACS_HLINE | (bottom[n] & (A_ATTRIBUTES | A_COLOR));
  mvaddchnstr(ybase + ydepth, xbase, bottom, xlength);
  mvaddch(ybase + ydepth,  xbase + xlength, ACS_LRCORNER);

  move(ybase,  xbase - 1);
  vline(ACS_VLINE, ydepth);

  move(ybase,  xbase + xlength);
  vline(ACS_VLINE, ydepth);

  if(hascolor)
    attrset(COLOR_PAIR(2));
}

/* Show Run Number , Start and Stop Times */
void showRunInfo(int info){
  /*
    info = 0 : Start Time
           1 : Stop Time
           2 : Run Number only
  */
  attron(yellowstr);
  attron(A_BOLD);
  mvprintw(yb,xb,"Run Number : %04d",runnumber);
  attroff(yellowstr);
  attron(cyanstr);
  if(info == 0){
    move(yb+2,0);
    hline(' ',COLS);
    move(yb+3,0);
    hline(' ',COLS);
    ttime = starttime;
    strtime = localtime(&ttime);
    mvprintw(yb+1,xb,"Start Time : %s",asctime(strtime));
    attroff(cyanstr);
  }else if(info == 1){
    attron(cyanstr);
    attron(A_BOLD);
    ttime = stoptime;
    strtime = localtime(&ttime);
    mvprintw(yb+2,xb,"Stop  Time : %s",asctime(strtime));
    attroff(cyanstr);
    attron(redstr);
    mvprintw(yb+3,xb,"Next  Run  : %04d",runnumber+1);
    attroff(redstr);
  }else{
    attron(redstr);
    mvprintw(yb+3,xb,"Next  Run  : %04d",runnumber+1);
    attroff(redstr);
    attroff(cyanstr);
  }
  attroff(A_BOLD);
}

/* DAQ Command */
void daqStart(int mode){
  /* mode 0 : Normal Run
          1 : Pedestal Run
  */
  sendbuf[0] = 1;
  send(dbsock,sendbuf,1024,0);
  recv(dbsock,recvbuf,6,MSG_WAITALL);
  memcpy((char *)&runnumber,recvbuf,2);
  memcpy((char *)&starttime,recvbuf+2,4);
  makeComment(0);
  memcpy(sendbuf+1,(char *)&runnumber,2);
  memcpy(sendbuf+3,(char *)&comment,100);
  memcpy(sendbuf+103,header,256);
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
  //iLog(sendbuf);
  if(mode == 1){
    sendbuf[0] = 6;
  }
  send(colsock,sendbuf,1024,0);
  recv(colsock,recvbuf,1,MSG_WAITALL);
  startflag = 1;

  if(autorunflag == 1){
    mvprintw(ymes,xmes,"Auto run Start             ");
    attron(redstr);
    mvprintw(ysta,xsta,"Auto %2d",autorunn);
    attroff(redstr);
    move(yc,xc);
    deleteln();
    printw("Command> ");
  }
  /* commentflag = 1; */
}

void daqStop(void){
  char tmpyn[128];

  memset(tmpyn,0,sizeof(tmpyn));
  sendbuf[0] = 2;
  send(dbsock,sendbuf,1024,0);
  recv(dbsock,recvbuf,6,MSG_WAITALL);
  memcpy((char *)&runnumber,recvbuf,2);
  memcpy((char *)&stoptime,recvbuf+2,4);
  send(colsock,sendbuf,1024,0);
  recv(colsock,recvbuf,1,MSG_WAITALL);
  if(startflag == 1){
    if(mtfullstopflag != 1){
      mvprintw(yc+1,xc,"Ender  : ");
      memset(ender,0x20,256);
      getstr(ender);
      move(yh+2,xh);
      hline(' ',COLS);
      move(yh+3,xh);
      hline(' ',COLS);
      mvprintw(yh+2,xh,"Ender : %s",ender);

      move(yc+2,xc);
      hline(' ',COLS);
      mvprintw(yc+2,xc,"Do you want to prisca? [y]/n : ");
      getstr(tmpyn);
      autorunn = 0;
      autorunflag = 0;
      if(tmpyn[0] != 'n'){
	prisca();
      }
    }else if(autorunflag == 0){
      strcpy(ender,"MT of HD Full!!  Stopped by babarlDAQ.");
      move(yh+2,xh);
      hline(' ',COLS);
      move(yh+3,xh);
      hline(' ',COLS);
      mvprintw(yh+2,xh,"Ender : %s",ender);
      autorunn = 0;
    }else{
      strcpy(ender,"HD is Full, next Run auto start       ");
      move(yh+2,xh);
      hline(' ',COLS);
      move(yh+3,xh);
      hline(' ',COLS);
      mvprintw(yh+2,xh,"Ender : %s",ender);
    }
    move(yc,xc);
    deleteln();
    makeComment(1);
    memcpy(sendbuf+3,(char *)&comment,100);
    memcpy(sendbuf+103,ender,256);
    send(recsock,sendbuf,1024,0);
    recv(recsock,recvbuf,1,MSG_WAITALL);
    //iLog(sendbuf);
  }
  startflag = 0;
  if(stmode == 1){
    showmtstat();
  }
  if(mtfullstopflag == 1){
    mtfullstopflag = 0;
    bzero(com,40);
    bzero(sendbuf,1024);
    bzero(recvbuf,1024);
    move(yc,xc);
    deleteln();
    printw("Command> ");
  }
}

void nosaveStart(void){
  sendbuf[0] = 3;
  send(dbsock,sendbuf,1024,0);
  recv(dbsock,recvbuf,6,MSG_WAITALL);
  memcpy((char *)&runnumber,recvbuf,2);
  memcpy((char *)&starttime,recvbuf+2,4);
#ifndef UDP
  sendbuf[0] = 4;
  makeComment(0);
  memcpy(sendbuf+1,(char *)&runnumber,2);
  memcpy(sendbuf+3,(char *)&comment,100);
  memcpy(sendbuf+103,header,256);
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
#endif
  sendbuf[0] = 3;
  memcpy(sendbuf+1,(char *)&runnumber,2);
  send(colsock,sendbuf,1024,0);
  recv(colsock,recvbuf,1,MSG_WAITALL);
  move(yh,xh);
  hline(' ',COLS);
  move(yh+1,xh);
  hline(' ',COLS);
  move(yh+2,xh);
  hline(' ',COLS);
  startflag = 3;
}

void nosavePed(void){
  sendbuf[0] = 3;
  send(dbsock,sendbuf,1024,0);
  recv(dbsock,recvbuf,6,MSG_WAITALL);
  memcpy((char *)&runnumber,recvbuf,2);
  memcpy((char *)&starttime,recvbuf+2,4);
#ifndef UDP
  sendbuf[0] = 4;
  makeComment(0);
  memcpy(sendbuf+1,(char *)&runnumber,2);
  memcpy(sendbuf+3,(char *)&comment,100);
  memcpy(sendbuf+103,header,256);
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);
#endif
  sendbuf[0] = 9;
  memcpy(sendbuf+1,(char *)&runnumber,2);
  send(colsock,sendbuf,1024,0);
  recv(colsock,recvbuf,1,MSG_WAITALL);
  move(yh,xh);
  hline(' ',COLS);
  move(yh+1,xh);
  hline(' ',COLS);
  move(yh+2,xh);
  hline(' ',COLS);
  startflag = 3;
}

void setrunnumber(void){
  sendbuf[0] = 12;
  memcpy(sendbuf+1,(char *)&run,2);
  send(dbsock,sendbuf,1024,0);
  recv(dbsock,recvbuf,2,0);
  memcpy((char *)&runnumber,recvbuf,2);
}

void updatescrname(void){
  sendbuf[0] = 42;
  send(dbsock,sendbuf,1024,0);
  recv(dbsock,recvbuf,2,0);
}

void clearscr(void){
  sendbuf[0] = 43;
  send(dbsock,sendbuf,1024,0);
  recv(dbsock,recvbuf,2,0);
}

void setped(void){
  sendbuf[0] = 7;
  send(colsock,sendbuf,1024,0);
  recv(colsock,recvbuf,1,MSG_WAITALL);
}

void setthre(void){
  sendbuf[0] = 8;
  send(colsock,sendbuf,1024,0);
  recv(colsock,recvbuf,1,MSG_WAITALL);
}

void nextautorun(void){
  char tmps[256];
  autorunflag = 1;
  autorunn++;
  memset(header,0x20,256);
  memset(tmps,0x20,256);
  sprintf(tmps,"Auto file %d, (start run = %d)",autorunn,autostock);
  strcpy(header,tmps);
  headerflag = 1;
  daqStart(0);
  showRunInfo(0);
}

void mtfullstop(void){
  mvprintw(ymes,xmes,"Stop                         ");
  attron(redstr);
  mvprintw(ysta,xsta,"Stop    ");
  attroff(redstr);
  mtfullstopflag = 1;
  if(autorunflag == 1 && autorunn >= 10){
    autorunflag = 0;
    autorunn = 0;
  }
  daqStop();
  showRunInfo(1);
  headerflag = 0;
  if(autorunflag == 1 && autorunn < 10){
    nextautorun();
  }
}

void initscreen(void){
  attron(A_BOLD);
  attron(linestr);
  hline(' ',COLS);
  //vline(' ',yc-1);
  //move(0,COLS-1);
  //vline(' ',yc-1);
  move(yc-1,0);
  hline(' ',COLS);
  attroff(linestr);
  attroff(A_BOLD);

  //drawbox(25,4,40,4);
  mvaddstr(1,10,"----- babarlDAQ Controller (Nov 6, 2003) -----");
  showststat();
  showRunInfo(2);
}

/* Main */
int main(int argc,char *argv[]){

  mtflag = 0;
  stmode = 0;
  mtnum = 1;
  autorunflag = 0;
  autorunn = 0;
  mtfullsize = MTFULLSIZE;
  hdfullsize = HDFULLSIZE;


  /* argv */
  /* printf("%d\n",argc); */
  if(argc == 2){
    if(strcmp(argv[1],"mt") == 0 || strcmp(argv[1],"mt1") == 0){
      stmode = 1;
    }else if(strcmp(argv[1],"mt2") == 0){
      stmode = 1;
      mtnum = 2;
    }
  }

  memset(tmpstr,0,sizeof(tmpstr));
  if(getenv("BBRL_DB") != NULL){
    strcpy(address.database,getenv("BBRL_DB"));
  }else{
    strcpy(address.database,"localhost");
  }
  if(getenv("BBRL_REC") != NULL){
    strcpy(address.recorder,getenv("BBRL_REC"));
  }else{
    strcpy(address.recorder,"localhost");
  }
  if(getenv("BBRL_COL") != NULL){
    strcpy(address.collector,getenv("BBRL_DB"));
  }else{
    strcpy(address.collector,"localhost");
  }
  if(getenv("BBRL_DAT") != NULL){
    strcpy(tmpstr,getenv("BBRL_DAT"));
    mtfullsize = strtoul(tmpstr,NULL,0);
  }
  if(getenv("BBRL_HD") != NULL){
    strcpy(tmpstr,getenv("BBRL_HD"));
    hdfullsize = strtoul(tmpstr,NULL,0);
  }
/*   if(getenv("ILOGSERVER") != NULL) { */
/*     strcpy(address.iLogServer,getenv("ILOGSERVER")); */
/*   } else { */
/*     strcpy(address.iLogServer,"localhost.localdomain"); */
/*   } */
    
  /* Read Address from address.txt */
  if((fp = fopen("address.txt","r")) != NULL){
    while(fscanf(fp,"%s %s\n",&com,&tmp) == 2){
      if(strcmp(com,"DATABASE") == 0){
	strcpy(address.database,tmp);
      }else if(strcmp(com,"RECORDER") == 0){
	strcpy(address.recorder,tmp);
      }else if(strcmp(com,"COLLECTOR") == 0){
	strcpy(address.collector,tmp);
      } else if (strcmp(com, "ILOGSERVER") == 0) {
	//strcpy(address.iLogServer,tmp);
      }
    }
    fclose(fp);
  }


  /* Set to 0 */
  bzero(com,40);
  bzero(sendbuf,1024);
  bzero(recvbuf,1024);


  /* Make Sockets */
  if((dbsock = socket(PF_INET,SOCK_STREAM,0)) < 0){
    perror("Error in dbsock\n");
    exit(1);
  }
  if((recsock = socket(PF_INET,SOCK_STREAM,0)) < 0){
    perror("Error in recsock\n");
    exit(1);
  }
  if((colsock = socket(PF_INET,SOCK_STREAM,0)) < 0){
    perror("Error in colsock\n");
    exit(1);
  }
  /* Set saddr to 0 */
  bzero((char *)&dbsaddr,sizeof(dbsaddr));
  bzero((char *)&recsaddr,sizeof(dbsaddr));
  bzero((char *)&colsaddr,sizeof(dbsaddr));

  /* Set Socket Name */

  /* Connect to Collector */
  if((colent = gethostbyname(address.collector)) == NULL){
    perror("No such host of collector.\n");
    exit(1);
  }
  bcopy(colent->h_addr,&colsaddr.sin_addr,colent->h_length);
  colsaddr.sin_family = AF_INET;
  colsaddr.sin_port = htons(COLLECTORPORT);
#ifdef DEBUG
  printf("(DEBUG) pass collector.\n");
#else
  if(connect(colsock,(struct sockaddr *)&colsaddr,sizeof(colsaddr)) < 0){
    perror("Can't connect colsock.\n");
    exit(1);
  }
  /* printf("Connecting established Collector.\n"); */
#endif

  /* Connect to Database */
  if((dbent = gethostbyname(address.database)) == NULL){
    perror("No such host of database.\n");
    exit(1);
  }
  bcopy(dbent->h_addr,&dbsaddr.sin_addr,dbent->h_length);
  dbsaddr.sin_family = AF_INET;
  dbsaddr.sin_port = htons(CONTROLPORT);
#ifdef DEBUG
  printf("(DEBUG) pass database.\n");
#else
  if(connect(dbsock,(struct sockaddr *)&dbsaddr,sizeof(dbsaddr)) < 0){
    perror("Can't connect dbsock.\n");
    exit(1);
  }
  /* printf("Connecting established Database.\n"); */
#endif

  /* Connect to Recorder */
  if((recent = gethostbyname(address.recorder)) == NULL){
    perror("No such host of recorder.\n");
    exit(1);
  }
  bcopy(recent->h_addr,&recsaddr.sin_addr,recent->h_length);
  recsaddr.sin_family = AF_INET;
  recsaddr.sin_port = htons(RECORDERPORT);
#ifdef DEBUG
  printf("(DEBUG) pass recorder.\n");
#else
  if(connect(recsock,(struct sockaddr *)&recsaddr,sizeof(recsaddr)) < 0){
    perror("Can't connect recsock.\n");
    exit(1);
  }
  /* printf("Connecting established Recorder.\n"); */
#endif

  /* initialize address */
  //InitiLogSock(address.iLogServer,ILOGPORT);

  /* Send Address to Collector */
  /* Database Address */
#ifndef DEBUG
  bzero(sendbuf,1024);
  sendbuf[0] = 4;
  memcpy(sendbuf+1,address.database,strlen(address.database));
  send(colsock,sendbuf,1024,0);
  recv(colsock,recvbuf,1,MSG_WAITALL);

  /* Recorder Address */
  bzero(sendbuf,1024);
  sendbuf[0] = 5;
  memcpy(sendbuf+1,address.recorder,strlen(address.recorder));
  send(colsock,sendbuf,1024,0);
  recv(colsock,recvbuf,1,MSG_WAITALL);

  /* Send Address to Recorder */
  /* Database Address */
  bzero(sendbuf,1024);
  sendbuf[0] = 3;
  memcpy(sendbuf+1,address.database,strlen(address.database));
  send(recsock,sendbuf,1024,0);
  recv(recsock,recvbuf,1,MSG_WAITALL);

  memset(hddir1,0,sizeof(hddir1));
  memset(hddir2,0,sizeof(hddir2));
  memset(tmp1,0,sizeof(tmp1));
  memset(tmp2,0,sizeof(tmp2));
  hdn = 1;
  maxhd = 1;
  if((fp = fopen("hddir.txt","r")) != NULL){
    while(fscanf(fp,"%s %s\n",&tmp1,&tmp2) == 2){
      if(strcmp(tmp1,"HD1") == 0){
	strcpy(hddir1,tmp2);
      }else if(strcmp(tmp1,"HD2") == 0){
	strcpy(hddir2,tmp2);
	hdn = 2;
	maxhd = 2;
      }
    }
    fclose(fp);
  }else{
    strcpy(hddir1,"./");
  }
  printf("Save into %s\n",hddir1);
  sethddir1();
  if(hdn == 2){
    printf("          %s\n",hddir2);
    sethddir2();
  }

  /* Recv Run Number from Database */
  bzero(sendbuf,1024);
  sendbuf[0] = 23;
  send(dbsock,sendbuf,1024,0);
  recv(dbsock,(char *)&runnumber,2,MSG_WAITALL);

  /* Init MT Status */
  init_mtstat(address.database);
#endif

  /* Screen Initiarize */
  initscr();
  start_color();
  if(use_default_colors() == ERR){
    bgcolor = COLOR_BLACK;
  }
  init_pair(1,COLOR_BLUE,bgcolor);
  bluestr = COLOR_PAIR(1);
  init_pair(2,COLOR_RED,bgcolor);
  redstr = COLOR_PAIR(2);
  init_pair(3,COLOR_CYAN,COLOR_CYAN);
  linestr = COLOR_PAIR(3);
  init_pair(4,COLOR_CYAN,bgcolor);
  cyanstr = COLOR_PAIR(4);
  init_pair(5,COLOR_YELLOW,bgcolor);
  yellowstr = COLOR_PAIR(5);

  initscreen();
  /*refresh();*/
  keypad(stdscr,TRUE);

  /* MT ON */
  if(stmode == 1){
    bzero(sendbuf,1024);
    bzero(recvbuf,1024);
    mton();
  }else{
    hdon();
  }

  /* Timer Thread */
  pthread_create(&timerthread_t,NULL,(void *)&timerthread,NULL);

  while(1){
    bzero(com,40);
    bzero(sendbuf,1024);
    bzero(recvbuf,1024);
    move(yc+1,xc+1);
    deleteln();
    move(yc,xc);
    deleteln();
    printw("Command> ");
    if(commentflag){
      attron(A_BOLD);
      attron(redstr);
      printw("Let't fill RUN SHEET!, are you OK?  [Press Enter]");
      attroff(redstr);
      attroff(A_BOLD);
      commentflag = 0;
    }
    scanw("%s",com);
    command = getCommand();
    move(10,1);
    hline(' ',COLS-2);
    switch(command){
    case 0:
      mvprintw(ymes,xmes,"%s: Command not found.     ",com);
      break;
    case 1:
    case 38:
      if(startflag == 0){
	if(headerflag != 1){
	  mvprintw(ymes,xmes,"No Header...               ");
	}else if(stmode == 1 && mtflag == 0){
	  mvprintw(ymes,xmes,"Try [mton] or [hdon].      ");
	}else{
	  if(command == 1){
	    autorunn = 0;
	    autorunflag  = 0;
	    mvprintw(ymes,xmes,"Start                      ");
	    attron(redstr);
	    mvprintw(ysta,xsta,"Running ");
	    attroff(redstr);
	  }else if(command == 38){
	    autorunn = 0;
	    autostock = runnumber+1;
	    autorunn++;
	    mvprintw(ymes,xmes,"Auto run Start             ");
	    attron(redstr);
	    mvprintw(ysta,xsta,"Auto %2d",autorunn);
	    attroff(redstr);
	    autorunflag = 1;
	  }
	  daqStart(0);
	  showRunInfo(0);
	}
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 2:
      if(startflag != 0){
	autorunflag = 0;
	autorunn = 0;
	mvprintw(ymes,xmes,"Stop                         ");
	attron(redstr);
	mvprintw(ysta,xsta,"Stop    ");
	attroff(redstr);
	daqStop();
	showRunInfo(1);
	headerflag = 0;
      }else{
	mvprintw(ymes,xmes,"Now stopping...              ");
      }
      break;
    case 3:
      if(startflag == 0){
	mvprintw(ymes,xmes,"Start with nosave mode       ");
	attron(redstr);
	mvprintw(ysta,xsta,"Nosave   ");
	attroff(redstr);
	nosaveStart();
	showRunInfo(0);
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 4:
      if(startflag == 0){
	mvprintw(ymes,xmes,"Header                       ");
	mvprintw(yc+1,xc,"Header : ");
	memset(header,0x20,256);
	getstr(header);
	headerflag = 1;
	move(yc,xc);
	deleteln();
	move(yh,xh);
	hline(' ',COLS);
	mvprintw(yh,xh,"Header : %s",header);
	move(yh+1,xh);
	hline(' ',COLS);
	move(yh+2,xh);
	hline(' ',COLS);
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 5:
      if(startflag != 0){
	mvprintw(ymes,xmes,"Now running...               ");
      }else{	
	mvprintw(ymes,xmes,"Exit");
	endwin();
	exitCommand();
      }
      break;
    case 6:
      if(startflag == 0){
	mvprintw(ymes,xmes,"Check                          ");
	checkCommand();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 7:
      mvprintw(ymes,xmes,"Add Client                     ");
      addClientCommand();
      break;
    case 8:
      if(startflag == 0){
	mvprintw(ymes,xmes,"MT On                        ");
	mton();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 9:
      if(startflag == 0){
	mvprintw(ymes,xmes,"MT Off -> HD On ");
	hdon();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 10:
      if(startflag == 0){
	mvprintw(ymes,xmes,"HD On                        ");
	hdon();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 11:
      if(startflag == 0){
	mvprintw(ymes,xmes,"MT One                       ");
	mtone();
	mton();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 12:
      if(startflag == 0){
	mvprintw(ymes,xmes,"MT Two                       ");
	mttwo();
	mton();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 13:
      if(startflag == 0){
	mvprintw(ymes,xmes,"Mount MT                     ");
	mtmou();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 14:
      if(startflag == 0){
	mvprintw(ymes,xmes,"Dismount MT                  ");
	mtdismou();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 15:
      if(startflag == 0){
	if(headerflag != 1){
	  mvprintw(ymes,xmes,"No Header...               ");
	}else if(stmode == 1 && mtflag == 0){
	  mvprintw(ymes,xmes,"Try [mton] or [hdon].      ");
	}else{
	  mvprintw(ymes,xmes,"Start Pedestal Run         ");
	  daqStart(1);
	  showRunInfo(0);
	}
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 16:
      if(startflag == 0){
	mvprintw(ymes,xmes,"Set Status & Pedestal        ");
	setped();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
      /*
	case 17:
	if(startflag == 0){
	mvprintw(ymes,xmes,"Calc Staus & Pedestal        ");
	mvprintw(yc+1,xc,"Pedestal Data : ");
	memset(peddat,0x20,40);
	getstr(peddat);
	mvprintw(yc+2,xc,"Pedestal Info : ");
	memset(calcfile,0x20,40);
	getstr(calcfile);
	calcpedestal();
	move(yc+1,xc);
	deleteln();
	deleteln();
	}else{
	mvprintw(ymes,xmes,"Now running...               ");
	}
	break;
	case 18:
	if(startflag == 0){
	mvprintw(ymes,xmes,"Copy staval.txt -> camac     ");
	mvprintw(yc+1,xc,"rcp path : ");
	memset(rcp,0x20,40);
	getstr(rcp);
	rcpstaval();
	move(yc,xc);
	deleteln();
	}else{
	mvprintw(ymes,xmes,"Now running...               ");
	}
	break;
	case 19:
	if(startflag == 0){
	mvprintw(ymes,xmes,"Set Threshold                ");
	setthre();
	}else{
	mvprintw(ymes,xmes,"Now running...               ");
	}
	break;
	case 20:
	if(startflag == 0){
	mvprintw(ymes,xmes,"Copy threval.txt -> camac     ");
	mvprintw(yc+1,xc,"rcp path : ");
	memset(rcp,0x20,40);
	getstr(rcp);
	rcpthreval();
	move(yc,xc);
	deleteln();
	}else{
	mvprintw(ymes,xmes,"Now running...               ");
	}
	break;
      */
    case 21:
      if(startflag == 0){
	mvprintw(ymes,xmes,"Set Runnumber                ");
	mvprintw(yc+1,xc,"Run Number : ");
	scanw("%d\n",&run);
	setrunnumber();
	showRunInfo(2);
	move(yc,xc);
	deleteln();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 22:
      if(startflag == 0){
	mvprintw(ymes,xmes,"Update Scaler name           ");
	updatescrname();
	move(yc,xc);
	deleteln();
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 23:
      mvprintw(ymes,xmes,"Clear Scaler                 ");
      clearscr();
      move(yc,xc);
      deleteln();
      break;
    case 30:
      mvprintw(ymes,xmes,"Please call  090-7903-4604  ");
      break;
    case 31:
      prisca();
      break;
    case 32:
      stdsca();
      break;
    case 33:
      clear();
      initscreen();
      break;
    case 34:
      if(startflag == 0){
	mvprintw(ymes,xmes,"Pedestal run without save       ");
	attron(redstr);
	mvprintw(ysta,xsta,"nsped     ");
	attroff(redstr);
	nosavePed();
	showRunInfo(0);
      }else{
	mvprintw(ymes,xmes,"Now running...               ");
      }
      break;
    case 35: //hdon 1
      sethd1();
      break;
    case 36: //hdon 2
      if(maxhd == 2){
	sethd2();
      }else{
	mvprintw(ymes,xmes,"HD Dir 2 is not set            ");
      }
      break;
    case 37: //max
      break;
    }
  }
  endwin();
  return 0;
}
