/* getmtstat.c

   Sep 11,2000
*/


#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <string.h>

#define DATABASEPORT  16700


int mtsock;
struct sockaddr_in mtsaddr;
static struct hostent *mtent;
char mtsendbuf[1024],mtrecvbuf[1024];


void init_mtstat(char hostname[40]){

  memset(mtsendbuf,0,1024);
  memset(mtrecvbuf,0,1024);
  mtsendbuf[0] = 26;

  /* saddr set to '0' */
  bzero((char *)&mtsaddr,sizeof(mtsaddr));

  /* set socket names */
  if((mtent = gethostbyname(hostname)) == NULL){
    perror("No such host");
    exit(1);
  }
  bcopy(mtent->h_addr,&mtsaddr.sin_addr,mtent->h_length);
  mtsaddr.sin_family = AF_INET;
  mtsaddr.sin_port = htons(DATABASEPORT);
}

void getmtstat(unsigned int *mtfull,unsigned int *mtused){
  /* Making of socket.*/
  if((mtsock = socket(PF_INET,SOCK_STREAM,0)) < 0){
    perror("Can't make socket.\n");
    //exit(1);
  }
  if(connect(mtsock,(struct sockaddr *)&mtsaddr,sizeof(mtsaddr)) < 0){
    perror("Can't connect.\n");
    //exit(1);
  }

  send(mtsock,mtsendbuf,1024,0);
  recv(mtsock,mtrecvbuf,1024,0);

  memcpy((char *)mtfull,mtrecvbuf,4);
  memcpy((char *)mtused,mtrecvbuf+4,4);

  close(mtsock);
}
