/* 
   Database
   Oct 31, 2002
   using Thread
   TCP Only mode
*/

#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <signal.h>
#include <pthread.h>

#include "multisender.c"
#include "bbrl.h"
#define SCRTOT  96
#define SCRNLEN 42

#if defined(__GNU_LIBRARY__) && !defined(MSG_WAITALL)
#define MSG_WAITALL 0x100
#endif

/* Prototype */
void child(void);
void controllCommand(char com);
void statusCommand(char com);
void sig(void);

/* Global */
static volatile int exitflag;
int sock1,sock2,listsock,disksock,contsock,contaccsock;
int len,listlen,disklen,ret;
int datasize = 0x4000;
struct sockaddr_in saddr,caddr,listsaddr,listcaddr,disksaddr,diskcaddr,
                   contsaddr,contcaddr;
unsigned char recvbuf[1024],sendbuf[1024],stbuf[1024],stlistbuf[0x4000],
  namestbuf[4096];
int listaccsock;
fd_set sockset;
char tmpname[SCRNLEN];

time_t nowtime;
FILE *logfile,*runfile,*scrfile;
char *runfilename = "runcounter.txt",
     *logfilename = "log.txt",
     *scrfilename = "scrname.txt",
     *hs;
short zero = 0;

/* Data Structure */
struct StaticData{
  char runflag; /* 0(not running) <-> 1 (running) */
  char runname[24];
  unsigned short runnumber; /* Run Number */
  unsigned int starttime;   /* Start Time */
  unsigned int stoptime;
  unsigned int scrnum;
  char priscaflag;
  char scrname[SCRTOT][SCRNLEN];
}static_data;

struct DynamicData{
  unsigned short listdata[0x2000];
  unsigned int fulldisk;
  unsigned int useddisk;
  unsigned int scaler[SCRTOT];
  unsigned int nowsca[SCRTOT];
}dynamic_data;

unsigned int blockcnt = 0; // for Test


/* Exec Command */
void controllCommand(char com){
  int i;
  switch(com){
    /* Run Coomands */
  case 1: // Run Start
    /* printf("Recv Start\n"); */
    blockcnt = 0;
    for(i=0;i<static_data.scrnum;i++){
      dynamic_data.scaler[i] = 0;
      dynamic_data.nowsca[i] = 0;
    }
    static_data.stoptime = 0;
    static_data.runflag = 1;
    static_data.priscaflag = 1;
    time(&nowtime);
    static_data.starttime = nowtime;
    static_data.runnumber++;
    memcpy(sendbuf,(char *)&static_data.runnumber,2);
    memcpy(sendbuf+2,(char *)&static_data.starttime,4);
    send(contaccsock,sendbuf,6,0);
    break;
  case 2: // Run Stop
    /* printf("Recv Stop\n"); */
    if(static_data.runflag == 1){
      static_data.priscaflag = 3;
      runfile = fopen(runfilename,"w");
      fprintf(runfile,"%d",static_data.runnumber);
      fclose(runfile);
    }else{
      static_data.priscaflag = 4;
    }
    static_data.runflag = 0;
    time(&nowtime);
    static_data.stoptime = nowtime;
    memcpy(sendbuf,(char *)&static_data.runnumber,2);
    memcpy(sendbuf+2,(char *)&static_data.stoptime,4);
    send(contaccsock,sendbuf,6,0);

    memset((char *)&dynamic_data.listdata,0x0a,4);
    for(i=0;i<3;i++){
      multisend((char *)&dynamic_data.listdata);
    }

    /* for Scaler Test
      printf("Block Cnt : %d\n",blockcnt);

      for(i=0;i<static_data.scrnum;i++){
      printf("i=%d   ",dynamic_data.scaler[i]);
      if(i%5 == 0){
      printf("\n");
      }
      }
      printf("\n");
    */

    break;
  case 3: // No Save Run Start
    blockcnt = 0;
    for(i=0;i<static_data.scrnum;i++){
      dynamic_data.scaler[i] = 0;
      dynamic_data.nowsca[i] = 0;
    }
    static_data.stoptime = 0;
    static_data.runflag = 2;
    static_data.priscaflag = 2;
    time(&nowtime);
    static_data.starttime = nowtime;
    memcpy(sendbuf,(char *)&zero,2);
    memcpy(sendbuf+2,(char *)&static_data.starttime,4);
    send(contaccsock,sendbuf,6,0);
    break;

    /* Parameter Commands */
  case 11: // Set Run Name
    for(i=0;i<24;i++){
      static_data.runname[i] = recvbuf[i+1];
    }
    sendbuf[0] = 1;
    send(contaccsock,sendbuf,1,0);
    break;
  case 12: // Set Run Number
    memcpy((char *)&static_data.runnumber,recvbuf+1,2);
    memcpy(sendbuf,(char *)&static_data.runnumber,2);
    send(contaccsock,sendbuf,2,0);
    break;
  case 23: // Get Run Number
    memcpy(sendbuf,(char *)&static_data.runnumber,2);
    send(contaccsock,sendbuf,2,0);
    break;
    /* Multi Client Commands */
  case 41: // Add Client
    hs = recvbuf+1;
    sendbuf[0] = addclient(hs);
    send(contaccsock,sendbuf,1,0);
    break;
  case 42: // Reload scr name
    /* Scaler */
    if((scrfile = fopen(scrfilename,"r")) != NULL){
      static_data.scrnum = 0;
      memset(tmpname,0,sizeof(tmpname));
      while(fgets(tmpname,SCRNLEN,scrfile) > 0){
	memset(static_data.scrname[static_data.scrnum],0,SCRNLEN);
	strncpy(static_data.scrname[static_data.scrnum],tmpname,strlen(tmpname)-1);
	static_data.scrnum++;
	dynamic_data.nowsca[static_data.scrnum] = 0;
	dynamic_data.scaler[static_data.scrnum] = 0;
	memset(tmpname,0,sizeof(tmpname));
      }
    }
    sendbuf[0] = 1;
    send(contaccsock,sendbuf,1,0);
    break;
  case 43: // Clear scaler
    for(i=0;i<static_data.scrnum;i++){
	dynamic_data.nowsca[i] = 0;
	dynamic_data.scaler[i] = 0;
    }
    sendbuf[0] = 1;
    send(contaccsock,sendbuf,1,0);
    break;
    /* Process Commands */
  case 91: // Check Process
    sendbuf[0] = 1;
    send(contaccsock,sendbuf,1,0);
    break;
  case 92: // Exit Database
    //static_data.runnumber++;
    runfile = fopen(runfilename,"w");
    fprintf(runfile,"%d",static_data.runnumber);
    fclose(runfile);
    exitflag = 0;
    //sendbuf[0] = 1;
    //send(contaccsock,sendbuf,1,0);
    sleep(1);
    kill(0,SIGKILL);
    sig();
    break;
  }
}

void statusCommand(char com){
  int i;

  memset(stbuf,0,1024);

  switch(com){
    /* Status Data Get Commands */
  case 21: // Get Run Flag
    stbuf[0] = static_data.runflag;
    send(sock2,stbuf,1,0);
    break;
  case 22: // Get Run Name
    send(sock2,stbuf,24,0);
    break;
  case 23: // Get Run Number
    if(static_data.priscaflag == 1 || static_data.priscaflag == 3){
      memcpy(stbuf,(char *)&static_data.runnumber,2);
    }else{
      stbuf[0] = 0;
      stbuf[1] = 0;
    }
    send(sock2,stbuf,2,0);
    /* printf("Run Number : %d\n",static_data.runnumber); */
    break;
  case 24: // Get Start Time
    /* printf("Recv Start Time\n"); */
    memcpy(stbuf,(char *)&static_data.starttime,4);
    send(sock2,stbuf,4,0);
  case 25: // Get Stop Time
    memcpy(stbuf,(char *)&static_data.stoptime,4);
    send(sock2,stbuf,4,0);
  case 26: // Get Disk Used
    memcpy(stbuf,(char *)&dynamic_data.fulldisk,4);
    memcpy(stbuf+4,(char *)&dynamic_data.useddisk,4);
    send(sock2,stbuf,8,0);
  case 27: // Get Scaler Info
    memset(namestbuf,0,4096);
    memcpy(namestbuf,(char *)&static_data.scrnum,4);
    for(i=0;i<static_data.scrnum;i++){
      memcpy(namestbuf+i*SCRNLEN+4,static_data.scrname[i],SCRNLEN);
    }
    send(sock2,namestbuf,4096,0);
    break;
  case 28: // Get Scaler Data
    memcpy(stbuf,(char *)&static_data.scrnum,4);
    for(i=0;i<static_data.scrnum;i++){
      memcpy(stbuf+(i+1)*4,&dynamic_data.scaler[i],4);
    }
    send(sock2,stbuf,1024,0);
    break;
  case 29: // Get Now Scaler Data
    memcpy(stbuf,(char *)&static_data.scrnum,4);
    for(i=0;i<static_data.scrnum;i++){
      memcpy(stbuf+(i+1)*4,&dynamic_data.nowsca[i],4);
    }
    send(sock2,stbuf,1024,0);
    break;
  case 30: // Get List Data
    memcpy(stlistbuf,(char *)&dynamic_data.listdata,0x4000);
    send(sock2,stlistbuf,0x4000,0);
    break;
  case 31: // Get Prisca Flag
    stbuf[0] = static_data.priscaflag;
    send(sock2,stbuf,1,0);
    break;
  }
}

void sig(void){
  printf("Database Exit\n");
  close(contaccsock);
  close(contsock);
  close(disksock);
  close(listsock);
  close(sock2);
  close(sock1);
  pthread_exit(NULL);

  exit(0);
}

/* Thread */
/* Control commnads */
void controlThread(void){
  if((contaccsock = accept(contsock,(struct sockaddr *)&contcaddr,&len)) < 0){
    perror("Error in accept contaccsock.\n");
    exit(1);
  }
  close(contsock);
  while(exitflag){
    recv(contaccsock,recvbuf,1024,MSG_WAITALL);
    controllCommand(recvbuf[0]);
    bzero(recvbuf,1024);
    bzero(sendbuf,1024);
  }
  close(contaccsock);
}

/* Disk Used */
void diskThread(void){
  unsigned char diskbuf[8];
  while(exitflag){
    recvfrom(disksock,diskbuf,8,0,(struct sockaddr *)&caddr,&listlen);
    memcpy((char *)&dynamic_data.fulldisk,diskbuf,4);
    memcpy((char *)&dynamic_data.useddisk,diskbuf+4,4);
    //printf("used %d\n",dynamic_data.useddisk);
  }
  close(disksock);
}

/* List Data */
void listThread(void){
  int i;

#ifndef UDP
  if((listaccsock = accept(listsock,(struct sockaddr *)&listcaddr,&listlen)) < 0){
    perror("Error in accept listsock (line 299).\n");
    exit(1);
  }
  FD_ZERO(&sockset);
  FD_SET(listaccsock,&sockset);
  printf("Connect with recorder\n\n");
#endif
  /* List Data Socket */
  while(exitflag){
#ifndef UDP
    if(select(listaccsock+1,&sockset,NULL,NULL,NULL) != 0){
      ret = recv(listaccsock,dynamic_data.listdata,0x4000,MSG_WAITALL);
    }
#else
    recvfrom(listsock,dynamic_data.listdata,datasize,0,(struct sockaddr *)&caddr,&listlen);
#endif
    /* printf("UDPLIST : %d\n",dynamic_data.listdata[4]); */

    multisend((char *)&dynamic_data.listdata);

    blockcnt++;
    for(i=0;i<static_data.scrnum;i++){
      dynamic_data.nowsca[i] = (unsigned int)dynamic_data.listdata[0x2000-(static_data.scrnum-i)*2];
      dynamic_data.nowsca[i] |= ((unsigned int)(dynamic_data.listdata[0x2000-(static_data.scrnum-i)*2+1]))<<16 & 0x00ff0000;
      dynamic_data.scaler[i] += dynamic_data.nowsca[i];
    }
  }
  close(exitflag);
}


/* Status commands */
void getStatus(void){
  recv(sock2,recvbuf,1024,MSG_WAITALL);
  statusCommand(recvbuf[0]);
  /* printf("%s\n",recvbuf);*/
  bzero(recvbuf,1024);
  bzero(sendbuf,1024);
}



/* Main */
int main(int argc,char *argv[]){
  int i;
  char anahost[100];
  FILE *fd;
  pthread_t controlthread,diskthread,listthread;
  int sock1opt = 1, disksockopt = 1, listsockopt = 1, contsockopt = 1;

  exitflag = 1; 
  static_data.priscaflag = 0;

  multisender();
  if(argc > 2){
    printf("You set Analyzer host too many.\n");
    exit(0);
  }else if(argc == 2){
    if(addclient(argv[1]) == -1){
      printf("No such host %s\n",anahost);
      exit(0);
    }
  }

  if((fd = fopen("clihosts.txt","r")) != NULL){
    while(fscanf(fd,"%s\n",anahost) > 0){
      printf("%s\n",anahost);
      if(addclient(anahost) == -1){
	printf("No such host %s\n",anahost);
	exit(0);
      }
    }
  }


  /* Scaler */
  if((scrfile = fopen(scrfilename,"r")) != NULL){
    static_data.scrnum = 0;
    while(fgets(tmpname,SCRNLEN,scrfile) > 0){
      strncpy(static_data.scrname[static_data.scrnum],tmpname,strlen(tmpname)-1);
      static_data.scrnum++;
      dynamic_data.nowsca[static_data.scrnum] = 0;
      dynamic_data.scaler[static_data.scrnum] = 0;
    }
  }

  /* Signal */
  signal(SIGINT,(void *)sig);

  /* Making of socket1, listsock, disksock.*/
  if((sock1 = socket(PF_INET,SOCK_STREAM,0)) < 0){
    perror("Can't make socket1.\n");
    exit(1);
  }
  if((contsock = socket(PF_INET,SOCK_STREAM,0)) < 0){
    perror("Can't make contsock.\n");
    exit(1);
  }
#ifndef UDP
  if((listsock = socket(PF_INET,SOCK_STREAM,0)) < 0){
    perror("Can't make listsock.\n");
    exit(1);
  }
#else
  if((listsock = socket(PF_INET,SOCK_DGRAM,0)) < 0){
    perror("Can't make listsock.\n");
    exit(1);
  }
#endif
  if((disksock = socket(PF_INET,SOCK_DGRAM,0)) < 0){
    perror("Can't make disksock.\n");
    exit(1);
  }

  setsockopt(sock1,SOL_SOCKET,SO_REUSEADDR,&sock1opt,sizeof(sock1opt));
  setsockopt(contsock,SOL_SOCKET,SO_REUSEADDR,&contsockopt,sizeof(contsockopt));
#ifndef UDP
  setsockopt(listsock,SOL_SOCKET,SO_REUSEADDR,&listsockopt,sizeof(listsockopt));
#endif
  setsockopt(disksock,SOL_SOCKET,SO_REUSEADDR,&disksockopt,sizeof(disksockopt));

  /* saddr set to '0' */
  bzero((char *)&saddr,sizeof(saddr));
  bzero((char *)&contsaddr,sizeof(contsaddr));
  bzero((char *)&listsaddr,sizeof(listsaddr));
  bzero((char *)&disksaddr,sizeof(disksaddr));  

  /* set sockets names */
  saddr.sin_family = AF_INET;
  saddr.sin_addr.s_addr = INADDR_ANY;
  saddr.sin_port = htons(DATABASEPORT);
  contsaddr.sin_family = AF_INET;
  contsaddr.sin_addr.s_addr = INADDR_ANY;
  contsaddr.sin_port = htons(CONTROLPORT);
  listsaddr.sin_family = AF_INET;
  listsaddr.sin_addr.s_addr = INADDR_ANY;
  listsaddr.sin_port = htons(ONLINEPORT);
  disksaddr.sin_family = AF_INET;
  disksaddr.sin_addr.s_addr = INADDR_ANY;
  disksaddr.sin_port = htons(DISKDATAPORT);

  /* bind sockets */
  if(bind(sock1,(struct sockaddr *)&saddr,sizeof(saddr)) < 0){
    perror("Can't bind socket1.\n");
    exit(1);
  }
  if(bind(contsock,(struct sockaddr *)&contsaddr,sizeof(contsaddr)) < 0){
    perror("Can't bind contsock.\n");
    exit(1);
  }
  if(bind(listsock,(struct sockaddr *)&listsaddr,sizeof(listsaddr)) < 0){
    perror("Can't bind listsocket.\n");
    exit(1);
  }
  if(bind(disksock,(struct sockaddr *)&disksaddr,sizeof(disksaddr)) < 0){
    perror("Can't bind disksocket.\n");
    exit(1);
  }

#ifndef UDP
  if(listen(listsock,1) < 0){
    perror("Can't listen listsock.");
    exit(1);
  }
#endif

  /* Status Data Initialize */
  static_data.runflag = 0;

  /* Read Run Number from runcounter.txt,
     if runcounter.txt don't exist, Run Number set to '0'. */
  runfile = fopen(runfilename,"r");
  if(runfile == NULL){
    static_data.runnumber = 0;
  }else{
    fscanf(runfile,"%d",&static_data.runnumber);
    fclose(runfile);
  }


  /* contsock listen */
  if(listen(contsock,1) < 0){
    perror("Can't listen contsock.");
    exit(1);
  }

  len = sizeof(caddr);
  listlen = sizeof(listcaddr);
  disklen = sizeof(diskcaddr);

  pthread_create(&controlthread,NULL,(void *)&controlThread,NULL);
  pthread_create(&diskthread,NULL,(void *)&diskThread,NULL);
  pthread_create(&listthread,NULL,(void *)&listThread,NULL);

  /* Accept */
  /* socket1 listen */
  if(listen(sock1,1) < 0){
    perror("Can't listen socket1.");
    exit(1);
  }

  while(exitflag){
    if((sock2 = accept(sock1,(struct sockaddr *)&caddr,&len)) < 0){
      perror("Error in accept socket1 and socket2\n");
      exit(1);
    }
    getStatus();
    close(sock2);
  }
  sig();
}
