#define MAXBUFF  0x1c00

#define OPSTART  0x0050
#define OPSTOP   0x0020
#define OPBUFF   0x0004
#define OPBUFFCL 0x0008
#define OPBUSYCL 0x0001
#define OPCLEAR  0x0002
#define OPPED    0x8000

// CAMAC LAM
#ifdef CAMACINT
#define LAMN     1
#define LAMA     0
#define LAMF    26
#define LAMC     9
#endif

// VME IRQ
#ifdef VMEINT
#define INTLEVEL 5
#endif

/* #define IOREG    0x70000000 */

// for CAMAC modules
#define OPRN    3   // Output Reg.

#define SCR1N   1   // 12Ch Scaler
#define SCR1L   12  // Length of SCR1
#define SCR1P   2
#define SCR2N   2   // 12Ch Scaler
#define SCR2L   12  // Length of SCR1
#define SCR2P   1

#define COINN   4   // Coin Reg.

// for BEAM LINE
#define PLTN    9   // Kaizu Octal TDC
#define PLTL    6   // Length of PLT(F2LT,F2RT,F3LT,F3RT,RF1,RF2)
#define PLAN    7   // LeCroy 2249A QDC
#define PLAL    4   // Length of PLA(F2LA,F2RA,F3LA,F3RA)

#define PPACA   0x61000000
#define PPACT   0x51000000

// IDs for segments
#define COINID   1   // COIN
#define BEAMID   2   // 
#define PPACTID  3
#define PPACAID  4


#ifdef CAMAC
#include "camac.c"
#endif

#ifdef VME
#include "v775.c"
#include "v785.c"
#include "v792.c"
#include "v767.c"
#include "sis3700.c"
#endif
