/* 
   getstatus.c
   Oct 7 , 2000
   H.Baba
*/

#include <stdio.h>
#include <string.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <time.h>

#define DATABASEPORT 16700
#if defined(__GNU_LIBRARY__) && !defined(MSG_WAITALL)
#define MSG_WAITALL 0x100
#endif

unsigned char stsendbuf[1024],strecvbuf[1024],stlistbuf[0x4000],
  namerecvbuf[4096];
int len,i;
int stsock;
time_t sttime;
struct hostent *hp;
struct sockaddr_in staddr;

void init_getstatus(char *hostname){

  bzero((char *)&staddr,sizeof(staddr));

  if((hp = gethostbyname(hostname)) == NULL){
    perror("No such host.");
    exit(1);
  }

  bcopy(hp->h_addr,&staddr.sin_addr,hp->h_length);
  staddr.sin_family = AF_INET;
  staddr.sin_port = htons(DATABASEPORT);
}


void get_data(unsigned char com){
  memset(stsendbuf,0,1024);
  memset(strecvbuf,0,1024);
  stsendbuf[0] = com;

  if((stsock = socket(PF_INET,SOCK_STREAM,0)) < 0){
    perror("Can't make socket.");
    exit(1);
  }
  if(connect(stsock,(struct sockaddr *)&staddr,sizeof(staddr)) < 0){
    perror("Can't connect.\n");
    exit(1);
  }

  if(com == 27){
    memset(namerecvbuf,0,4096);
    send(stsock,stsendbuf,1024,0);
    recv(stsock,namerecvbuf,4096,MSG_WAITALL);
  }else{
    if(com != 30){
      send(stsock,stsendbuf,1024,0);
      recv(stsock,strecvbuf,1024,0);
    }else{
      send(stsock,stsendbuf,1024,0);
      recv(stsock,stlistbuf,0x4000,MSG_WAITALL);
    }
  }
  close(stsock);

}

/* Get Run Flag */
void get_runflag(int *flag){
  get_data(21);
  *flag = strecvbuf[0];
}

/* Get Run Number */
void get_runnumber(int *runnumber){
  get_data(23);
  memcpy(runnumber,strecvbuf,2);
}

/* Get Start Time */
void get_starttime(time_t *starttime){
  get_data(24);
  memcpy(starttime,strecvbuf,sizeof(*starttime));
}

/* Get Stop Time */
void get_stoptime(time_t *stoptime){
  get_data(25);
  memcpy(stoptime,strecvbuf,4);
}

/* Get MT Used */
void get_mtused(unsigned int *full,unsigned int *used){
  get_data(26);
  memcpy(full,strecvbuf,4);
  memcpy(used,strecvbuf+4,4);
}

/* Get Scaler Info */
void get_scrinfo(int *scrnum,char scrname[SCRTOT][SCRNLEN]){
  get_data(27);
  memcpy(scrnum,namerecvbuf,4);
  for(i=0;i<*scrnum;i++){
    memcpy(scrname[i],namerecvbuf+i*SCRNLEN+4,SCRNLEN);
  }
}

/* Get Scaler Data */
void get_scrtotal(int *scrnum,unsigned int scaler[SCRTOT]){
  get_data(28);
  memcpy(scrnum,strecvbuf,4);
  for(i=0;i<*scrnum;i++){
    memcpy((char *)&scaler[i],strecvbuf+(i+1)*4,4);
  }
}

/* Get Now Scaler Data */
void get_scrdata(int *scrnum,unsigned int scaler[SCRTOT]){
  get_data(29);
  memcpy(scrnum,strecvbuf,4);
  for(i=0;i<*scrnum;i++){
    memcpy((char *)&scaler[i],strecvbuf+(i+1)*4,4);
  }
}

/* Get List Data */
void get_listdata(unsigned char listdata[0x4000]){
  get_data(30);
  memcpy(listdata,stlistbuf,0x4000);
}

/* Get Prisca Flag */
void get_priscaflag(int *flag){
  get_data(31);
  *flag = strecvbuf[0];
}
