/* prisca.c

   Print Scaler
   Nov 1 , 2001
   H.Baba
*/

#define SCRTOT  96
#define SCRNLEN 42

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>

#include "getstatus.c"

int i,j,pri,runnumber,scrnum,runflag,priscaflag;
char scrname[SCRTOT][SCRNLEN],strchar[20];
char dbhost[128],lprhost[128];
unsigned int nscaler[SCRTOT],scaler[SCRTOT];
time_t starttime,stoptime;

void print_scaler(int mode){
  FILE *fd;
  char lpr[80];

  if(mode == 0){
    fd = stdout;
  }else if(mode == 1){
    umask((mode_t)000);
    if((fd = fopen("/tmp/prisca","w")) == NULL){
      perror("Can't print\n");
    }
  }

  if(priscaflag == 1 || priscaflag == 3){
    fprintf(fd,"Run%d\n\n",runnumber);
  }else if(priscaflag == 2 || priscaflag == 4){
    fprintf(fd,"Nosave Run\n\n");
  }
  fprintf(fd,"Start -- %s",ctime(&starttime));
  if(starttime != 0){
    if(stoptime > starttime){
      fprintf(fd,"Stop  -- %s",ctime(&stoptime));
    }else{
      fprintf(fd,"Now Running...\n");
    }
  }else{
      fprintf(fd,"No Data\n");
  }
  fprintf(fd,"\n");
  fprintf(fd,"             Scaler Name :      Total\n\n");

  for(i=0;i<scrnum;i++){
    fprintf(fd,"%32s : ",scrname[i]);
    fprintf(fd,"%10lu ",scaler[i]);
    fprintf(fd,"\n");
  }

  if(mode == 1){
    fclose(fd);

    if(getenv("BBRL_LPR") != NULL){
      strcpy(lprhost,getenv("BBRL_LPR"));
      system("/usr/bin/a2ps -q -o /tmp/prisca.ps /tmp/prisca");
      sprintf(lpr,"lpr -P%s /tmp/prisca.ps",lprhost);
    }else{
      system("/usr/bin/a2ps -q -o /tmp/prisca.ps /tmp/prisca");
      sprintf(lpr,"lpr  -Pripslp2 /tmp/prisca");
    }
    system(lpr);
    system("rm -f /tmp/prisca");
    system("rm -f /tmp/prisca.ps");
  }
}

int main(int argc,char *argv[]){

  memset(dbhost,0,sizeof(dbhost));
  memset(lprhost,0,sizeof(lprhost));

  pri = 0;
  if(argc == 2){
    if(strcmp(argv[1],"-p") == 0){
      pri = 1;
    }else if(strcmp(argv[1],"-n") == 0){
      pri = 2;
    }
  }

  if(getenv("BBRL_DB") != NULL){
    strcpy(dbhost,getenv("BBRL_DB"));
  }else{
    strcpy(dbhost,"localhost\0");
  }

  init_getstatus(dbhost);

  get_runflag(&runflag);
  get_priscaflag(&priscaflag);
  get_starttime(&starttime);
  get_stoptime(&stoptime);
  get_runnumber(&runnumber);
  get_scrinfo(&scrnum,scrname);
  get_scrtotal(&scrnum,scaler);

  if(pri == 0 || pri == 1){
    print_scaler(0);
  }
  if(pri == 1 || pri == 2){
    print_scaler(1);
  }

  return 0;
}

