/* 
   Recorder 
   May 16, 2005
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <sys/mtio.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>

#include "bbrl.h"
#include "tcpsender.h"

#if defined(__GNU_LIBRARY__) && !defined(MSG_WAITALL)
#define MSG_WAITALL 0x100
#endif

/*
  contsock : TCP Server
  listsock : TCP Server
  disksock : UDP Client
*/

void disksend(void);


int i,ret,tape,mtsum,hdn;
unsigned int useddisk,fulldisk;
int listlen,contlen,disklen,disksock,listsock,contsock,
    contaccsock,listaccsock;
int datafile,datafile2;
char filename[256],databaseaddress[1024],sendbuf = 1;
char filename2[256];
char tmpstr[256],hddir1[256],hddir2[256];
unsigned short runnumber;
unsigned char diskbuf[8],contbuf[BLKSIZE],
              header[BLKSIZE],ender[BLKSIZE];
unsigned static char databuf[BLKSIZE];
struct sockaddr_in diskcaddr,listsaddr,listcaddr,
       contsaddr,contcaddr;
struct hostent *dbent;
fd_set sockset;


/* MT Operation
   req = 0 : CheckMT
   req = 1 : Set MTx1
   req = 2 : Set MTx2
   req = 3 : Get MT Position
   req = 4 : MT Rewind
   req = 9 : Offline MT
*/
int mtoperation(int req){
  int mtfd,ret;
  struct mtpos mtst;
  struct mtop mtstop;

  ret = 0;

  switch(req){
  case 0:
    /* Check MT */
    mtfd = open("/dev/nst0",O_RDWR);
    if(ioctl(mtfd,MTIOCPOS,&mtst) < 0){
      ret = -1;
    }else{
      useddisk = mtst.mt_blkno;
      disksend();
    }
    close(mtfd);
    if(mtsum == 2){
      mtfd = open("/dev/nst1",O_RDWR);
      if(ioctl(mtfd,MTIOCPOS,&mtst) < 0){
	ret = -1;
      }
      close(mtfd);
    }
    break;
  case 1:
    mtsum = 1;
    break;
  case 2:
    mtsum = 2;
    break;
  case 3:
    /* Get MT Position */
    mtfd = open("/dev/nst0",O_RDWR);
    if(ioctl(mtfd,MTIOCPOS,&mtst) < 0){
      ret = -1;
    }else{
      useddisk = mtst.mt_blkno;
      ret = useddisk;
    }
    close(mtfd);
    break;
  case 4:
    mtstop.mt_op = MTREW;
    mtstop.mt_count = 1;
    mtfd = open("/dev/nst0",O_RDWR);
    if(ioctl(mtfd,MTIOCTOP,&mtstop) < 0){
      ret = -1;
    }
    close(mtfd);
    if(mtsum == 2){
      mtfd = open("/dev/nst1",O_RDWR);
      if(ioctl(mtfd,MTIOCTOP,&mtstop) < 0){
	ret = -1;
      }
      close(mtfd);
    }
    break;
  case 9:
    mtstop.mt_op = MTOFFL;
    mtstop.mt_count = 1;
    mtfd = open("/dev/nst0",O_RDWR);
    if(ioctl(mtfd,MTIOCTOP,&mtstop) < 0){
      ret = -1;
    }
    close(mtfd);
    if(mtsum == 2){
      mtfd = open("/dev/nst1",O_RDWR);
      if(ioctl(mtfd,MTIOCTOP,&mtstop) < 0){
	ret = -1;
      }
      close(mtfd);
    }
    break;
  case 10:
    mtstop.mt_op = MTSETBLK;
    mtstop.mt_count = 16384;
    mtfd = open("/dev/nst0",O_RDONLY);
    if(ioctl(mtfd,MTIOCTOP,&mtstop) < 0){
      ret = -1;
    }
    close(mtfd);
    if(mtsum == 2){
      mtfd = open("/dev/nst1",O_RDWR);
      if(ioctl(mtfd,MTIOCTOP,&mtstop) < 0){
	ret = -1;
      }
      close(mtfd);
    }
    break;
  }

  return ret;
}

/* receive List Data */
void receivedata(int mm){
  if(mm != 1){
    /* Run Number Name Header */
    memcpy((char *)&runnumber,contbuf+1,2);
    memcpy(header,contbuf+3,260);
    /* printf("START\n"); */
    /* Data File */
    if(tape == 0){
      sprintf(filename,"%s/%04d.rdf",hddir1,runnumber);
      sprintf(filename2,"%s/%04d.rdf",hddir2,runnumber);
      mtsum = 1;
      datafile = open(filename,O_WRONLY|O_CREAT,0444);
      if(hdn == 2){
	datafile2 = open(filename2,O_WRONLY|O_CREAT,0444);
      }
      useddisk = 0;
    }else{
      mtoperation(3);
      datafile = open("/dev/nst0",O_WRONLY);
      if(mtsum == 2){
	datafile2 = open("/dev/nst1",O_WRONLY);
      }
    }
    write(datafile,header,BLKSIZE);
    useddisk++;
    if(mtsum == 2 || hdn == 2){
      write(datafile2,header,BLKSIZE);
    }
  }
  sendbuf = 1;
  send(contaccsock,&sendbuf,1,0);
  
  if((listaccsock = accept(listsock,(struct sockaddr *)&listcaddr,&listlen)) < 0){
    perror("Error in accept listsock (line 191).\n");
    exit(1);
  }
  /* printf("accept transfer.\n");*/
  //close(listsock);
  FD_ZERO(&sockset);
  FD_SET(listaccsock,&sockset);
  while(1){
    if(select(listaccsock+1,&sockset,NULL,NULL,NULL) != 0){
      ret = recv(listaccsock,databuf,BLKSIZE,MSG_WAITALL);
    }
    if(databuf[0] == 0xff){
      break;
    }else{
      if(mm != 1){
	write(datafile,databuf,BLKSIZE);
	useddisk++;
	if(mtsum == 2 || hdn == 2){
	  write(datafile2,databuf,BLKSIZE);
	}
	if(useddisk % 10 == 0){
	  disksend();
	}
      }
      /*printf("Receive : %d\n",ret);*/
      tcpsend(databuf);
    }
  }
  close(listaccsock);

  if(mm != 1){
    /* Receive Ender */
    sendbuf = 1;
    recv(contaccsock,contbuf,1024,MSG_WAITALL);
    send(contaccsock,&sendbuf,1,0);
    memcpy(ender,contbuf+3,260);
    write(datafile,ender,BLKSIZE);
    useddisk++;
    if(mtsum == 2 || hdn == 2){
      write(datafile2,ender,BLKSIZE);
    }
    close(datafile);
    if(mtsum == 2 || hdn == 2){
      close(datafile2);
    }
    /* Update MT Position */
    if(tape == 1){
      mtoperation(0);
    }
    disksend();
  }
}

/* Init Database */
void initdiskused(){
  if((disksock = socket(AF_INET,SOCK_DGRAM,0)) < 0){
    perror("Can't make disksock.\n");
    exit(1);
  }
  bzero((char *)&diskcaddr,sizeof(diskcaddr));
  /* Hostname */
  if((dbent = gethostbyname(databaseaddress)) == NULL){
    perror("Error gethostbyname\n");
    exit(1);
  }
  bcopy(dbent->h_addr,&diskcaddr.sin_addr,dbent->h_length);
  diskcaddr.sin_family = AF_INET;
  diskcaddr.sin_port = htons(DISKDATAPORT);
  disklen = sizeof(diskcaddr);
}

void disksend(void){
  memcpy(diskbuf+4,(char *)&useddisk,4);
  sendto(disksock,diskbuf,8,0,(struct sockaddr *)&diskcaddr,sizeof(diskcaddr));
}

/* Main */
int main(int argc,char *argv[]){
  int contsockopt = 1, listsockopt = 1;


  /* Buffer set 0 */
  memset(contbuf,0,sizeof(contbuf));
  memset(databuf,0,sizeof(databuf));
  memset(header,0,sizeof(header));
  memset(ender,0,sizeof(ender));
  memset(tmpstr,0,sizeof(tmpstr));

  tape = 0;
  if(argc > 1){
    if(strcmp(argv[1],"tape") == 0){
      tape = 1;
    }
  }

  /* fulldisk = 85196; */
  fulldisk = MTFULLSIZE;

  memcpy(diskbuf,(char *)&fulldisk,4);

  memset(hddir1,0,sizeof(hddir1));
  memset(hddir2,0,sizeof(hddir2));
  hdn = 1;


  /* Making of contsock,listsock,disksock */
  if((contsock = socket(AF_INET,SOCK_STREAM,0)) < 0){
    perror("Can't make contsocket.\n");
    exit(1);
  }
  if((listsock = socket(AF_INET,SOCK_STREAM,0)) < 0){
    perror("Can't make listsock.\n");
    exit(1);
  }

  setsockopt(contsock, SOL_SOCKET, SO_REUSEADDR, &contsockopt, sizeof(contsockopt));
  setsockopt(listsock, SOL_SOCKET, SO_REUSEADDR, &listsockopt, sizeof(listsockopt));

  /* saddr set to '0' */
  bzero((char *)&contsaddr,sizeof(contsaddr));
  bzero((char *)&listsaddr,sizeof(listsaddr));  


  /* set sockets names */
  contsaddr.sin_family = AF_INET;
  contsaddr.sin_addr.s_addr = INADDR_ANY;
  contsaddr.sin_port = htons(RECORDERPORT);
  listsaddr.sin_family = AF_INET;
  listsaddr.sin_addr.s_addr = INADDR_ANY;
  listsaddr.sin_port = htons(LISTDATAPORT);

  /* bind sockets */
  if(bind(contsock,(struct sockaddr *)&contsaddr,sizeof(contsaddr)) < 0){
    perror("Can't bind contsocket.\n");
    exit(1);
  }
  if(bind(listsock,(struct sockaddr *)&listsaddr,sizeof(listsaddr)) < 0){
    perror("Can't bind listsocket.\n");
    exit(1);
  }

  /* socket1 listen */
  if(listen(contsock,1) < 0){
    perror("Can't listen contsock.");
    exit(1);
  }
  if(listen(listsock,1) < 0){
    perror("Can't listen listsock.");
    exit(1);
  }

  contlen = sizeof(contcaddr);
  listlen = sizeof(listcaddr);

  /* Accept */
  if((contaccsock = accept(contsock,(struct sockaddr *)&contcaddr,&contlen)) < 0){
    perror("Error in accept contsock.\n");
    exit(1);
  }
  close(contsock);
  while(1){
    recv(contaccsock,contbuf,1024,MSG_WAITALL);
    switch(contbuf[0]){
    case 1: // Run Start
      receivedata(0);
      break;
    case 2: // Run Stop
      //sendbuf = 1;
      //send(contaccsock,&sendbuf,1,0);
      break;
    case 3: // Set Database Address
      memcpy(databaseaddress,contbuf+1,strlen(contbuf+1));
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      printf("Try connect to DATABASE.\n");
      tcpsender(databaseaddress,ONLINEPORT);
      initdiskused();
      /* printf("Database : %s\n",databaseaddress); */
      break;
    case 4: // Run Start without save
      receivedata(1);
      break;
    case 41: // Set MT Mode
      tape = 1;
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 42: // Set HD Mode
      tape = 0;
      useddisk = 0;
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 43: // Set HD Dir1
      memset(hddir1,0,sizeof(hddir1));
      memcpy(hddir1,contbuf+1,strlen(contbuf+1));
      hdn = 1;
      tape = 0;
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      printf("HD1 %s\n",hddir1);
      break;
    case 44: // Set HD Dir2
      memset(hddir2,0,sizeof(hddir2));
      memcpy(hddir2,contbuf+1,strlen(contbuf+1));
      hdn = 2;
      tape = 0;
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      printf("HD2 %s\n",hddir2);
      break;
    case 45: // Set HD1 only
      tape = 0;
      useddisk = 0;
      hdn = 1;
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 46: // Set HD1 & 2
      tape = 0;
      useddisk = 0;
      hdn = 2;
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 49: // Set MAX size
      memcpy((char *)&fulldisk,contbuf+1,4);
      memcpy(diskbuf,(char *)&fulldisk,4);
      disksend();
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 51: // Check MT
      tape = 1;
      if(mtoperation(0) != 0){
	sendbuf = 5;
      }else{
	sendbuf = 1;
      }
      send(contaccsock,&sendbuf,1,0);
      break;
    case 52: // Set MT ONE
      mtoperation(1);
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 53: // Set MT TWO
      mtoperation(2);
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 54: // Get MT Position
      mtoperation(3);
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 55: // Rewind MT (mou)
      mtoperation(10);
      mtoperation(4);
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 59: // Offline MT
      mtoperation(9);
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 91: // Check Process
      sendbuf = 1;
      send(contaccsock,&sendbuf,1,0);
      break;
    case 92: // Exit Collector
      close(contaccsock);
      close(contsock);
      close(listsock);
      close(listaccsock);
      tcpclose();
      exit(0);
      break;
    }
  }
}
