/* transfer
   Nov 11, 2003

   Polling & Double Buffer
   with mbuff
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <mbuff.h>

#include "tcpsender.h"
#include "bbrl.h"

int main(int argc,char *argv[]){
  int first = 0;
  unsigned int save;
  volatile unsigned char *user_ptr;
  char *databasehost,*recorderhost;
  char ddata[BLKSIZE];
  short cle = 0x0000;
  int shmsize = BLKSIZE*2+8;
  int flagidx = BLKSIZE*2;

  /* set priority */
  nice(-20);

  /* clear buffer */
  memset(ddata,0,sizeof(ddata));
  ddata[0] = 0xff;

  /* save = 1 -> no save mode */
  save = 0;
  if(argc != 4){
    printf("You must set Database Host and Recorder.\n");
    exit(0);
  }else{
    databasehost = argv[1];
    recorderhost = argv[2];
    if(strcmp(argv[3],"nosave") == 0){
      save = 1;
    }
  }

  tcpsender(recorderhost,LISTDATAPORT);

  /* mbuff allocate shared memroy area */
  if((user_ptr=(volatile char *)mbuff_alloc(BBRL_SHM,shmsize)) == NULL){
    perror("Can't alloc shared memory (transfer).\n");
    exit(1);
  }

  /* main loop */
  while(1){
    /* through previous run's END flag */
    if(first == 0){
      if(user_ptr[flagidx] == 0xee){
	usleep(2);
      }else{
	first = 1;
      }
    }
    if(first == 1){
      /* check buffer FULL */
      if(user_ptr[flagidx] == 0x00 && user_ptr[flagidx+2] == 0x00){
	usleep(1);
      }else{
	if(user_ptr[flagidx] != 0xee){
	  /* buffer FULL */
	  /* buffer-1 FULL */
	  if(user_ptr[flagidx] == 0x01){
	    tcpsend((char *)user_ptr);
	    /* clear buffer-1 FULL */
	    if(user_ptr[flagidx] != 0xee){
	      //usleep(1);
	      memcpy((char *)(user_ptr+flagidx),(char *)&cle,2);
	    }
	    //printf("Send1\n");
	  /* buffer-2 FULL */
	  }else if(user_ptr[flagidx+2] == 0x02){
	      tcpsend((char *)(user_ptr+BLKSIZE));
	    /* clear buffer-2 FULL */
	      //usleep(1);
	    memcpy((char *)(user_ptr+flagidx+2),(char *)&cle,2);
	    //printf("Send2\n");
	  }
	}else{
	  /* run END */
	  tcpsend(ddata);
	  printf("Exit\n");
	  break;
	}
      }
    }
  }

  /* un map */
  mbuff_free(BBRL_SHM,(void *)user_ptr);

  tcpclose();

  return 0;
}

