/* udpsender.c
   This program transfer Data to Database with UDP.
   Aug 8, 2000
*/

#include <stdio.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define DATABASEPORT 16702

int udpsock;
struct sockaddr_in udpsaddr;

int udpsend(char *buf){
  int ret;
  ret = sendto(udpsock,buf,0x4000,0,(struct sockaddr *)&udpsaddr,sizeof(udpsaddr));
  return ret;
}

void udpclose(void){
  shutdown(udpsock,2);
  close(udpsock);
}

void udpsender(char *host){
  int i;
  struct hostent *hp;

  if((udpsock = socket(AF_INET,SOCK_DGRAM,0)) < 0){
    perror("Socket");
    exit(1);
  }

  if((hp = gethostbyname(host)) == NULL){
    perror("No such host");
    exit(1);
  }

  bcopy(hp->h_addr,&udpsaddr.sin_addr,hp->h_length);
  udpsaddr.sin_family = AF_INET;
  udpsaddr.sin_port = htons(DATABASEPORT);
}
